type t = { dim1 : int; dim2 : int; dim3 : int; data : float array; }
val dim1 : t -> int
val dim2 : t -> int
val dim3 : t -> int
val data : t -> float array
val at : t -> int -> int -> int -> int
val from : t -> int -> int * int * int
val init : int -> int -> int -> (int -> int -> int -> float) -> t
val make : int -> int -> int -> float -> t
val get : t -> int -> int -> int -> float
val unsafe_get : t -> int -> int -> int -> float
val set : t -> int -> int -> int -> float -> unit
val unsafe_set : t -> int -> int -> int -> float -> unit
val iter3 : int -> int -> (float -> unit) -> t -> unit
val iteri3 : int -> int -> (int -> float -> unit) -> t -> unit
val to_array : t -> float array array array
val of_array : float array array array -> t
val sub1 : int -> t -> t
val sum : t -> float
val sum_sub1 : int -> t -> float
val scale : float -> t -> t

val ( .@() ) : t -> int * int * int -> float
val ( .@()<- ) : t -> int * int * int -> float -> unit
